#include"DxLib.h"
#include<math.h>
#include<stdio.h>
#include<stdlib.h>

#define RAD (3.14159265/180)

typedef struct Bullet{
	double x;//xW
	double y;//yW
	int flag;//tO
	int kind;//(ŏ͏eAɃp[AbvA[U[,˃[U[)
	int syurui;//ށi@pAGp)
	double angle;
	double speed;
	int vx,vy;
	double OldX,OldY;
}Bullet;

typedef struct Enemy{
	double x,y;//x,yW
	int width,height;//A
	int flag;//otO
	int kind;//
	int movekind;//
	int hp;//HP(qbg|Cg)
	int tmp[100];//⏕ϐ
}Enemy;

typedef struct Explosion{
	int x,y;
	int time;
	int count;
	int frame;
	int flag;
}Explosion;

#define TAMA 0
#define LASER 1 //@̃Vbg^Cv̒萔
#define REFLASER 2 //˃[U[


int tbl[]={128,96,0,32,64};//[l

int sx=0,sy=0;//XN[l
int image;//@̃C[W
int image2;//wĩC[W
int image3[100];//G
int SE[100];//ʉ

int x=50;//xW
int y=(240-32)/2;//yW
int roll=20;//rolll (/10)
Bullet T[100]={0};
Enemy E[100]={0};
Explosion Ex[100]={0};
int Map[3][30][300]={0};
int MChip[256];
int xx[128];
int yy[128];

void ShotTheGunLaser(int x,int y,int kind,int angle,int speed,int syurui);//֐vg^Cv錾

float Arctan(double sx,double sy,double mx,double my)
{
	double tmp; 
	short angle; 
	tmp=atan2(-double(sy-my),double(sx-mx)); 
	tmp/=3.1415926535; 
	tmp*=180; 
	tmp+=360; 
	angle=(short)tmp%360;
	return angle;
}

void ShowEx(int x,int y,int time)
{
	int i;

	for(i=0;i<100;i++)
	{
		if(Ex[i].flag==0)
		{
			Ex[i].flag=1;
			Ex[i].x=x;
			Ex[i].y=y;
			Ex[i].time=time;
			break;
		}
	}
}

void DrawAndMoveEx()
{
	int i;

	for(i=0;i<100;i++)
	{
		if(Ex[i].flag==1)
		{

			DrawRectGraph(Ex[i].x,Ex[i].y,Ex[i].count*64,0,64,64,
				image3[1],TRUE,FALSE);

			Ex[i].frame++;
			if(Ex[i].time<Ex[i].frame)
			{
				Ex[i].count++;
				if(Ex[i].count>3)
				{
					Ex[i].flag =0;
					Ex[i].count=0;
					Ex[i].frame=0;
				}

			}
		}
	}
}

void ShowEnemy(int x,int y,int hp,int movekind,int kind)
{
	int i;

	for(i=0;i<100;i++)
	{
		if(E[i].flag ==0)
		{
			E[i].flag =1;
			E[i].x=x;
			E[i].y=y;
			E[i].width =32;
			E[i].height =32;
			E[i].hp=hp;
			E[i].kind=kind;
			E[i].movekind=movekind;
			break;
		}
	}
}

void SearchEnemy(void)
{
	int temp[15];
	int i;

	for(i=0;i<15;i++)
    {    
		if(sx==(sx/16)*16) //ỸXN[l16Ŋ؂ꂽ
		{
			temp[i]=Map[1][i][sx/16];
			if(temp[i]>0)
			{
				switch(temp[i])
				{
					case 1:
						ShowEnemy(320+32,i*16,3,0,temp[i]);//
						break;
					
				}
			}
		}
	}

}

void DrawEnemy()
{
	int i;

	for(i=0;i<100;i++)
	{
		if(E[i].flag ==1)
		{
			switch(E[i].kind)
			{
			case 1:
				DrawGraph(E[i].x,E[i].y,image3[0],TRUE);
				break;
			}
		}
	}
}

void MoveEnemy()
{
	int i;

	for(i=0;i<100;i++)
	{
		if(E[i].flag ==1)
		{
			switch(E[i].kind)
			{
			case 1:
				{
					static int angle[100]={0};
				E[i].x-=2;
				E[i].y+=sin(angle[i]*RAD)*3;
				angle[i]=(angle[i]+10)%360;
				E[i].tmp[0]++;
				if(E[i].tmp[0]>90)
				{
					E[i].tmp[0]=0;
					ShotTheGunLaser(E[i].x,E[i].y,0,Arctan(x,y,E[i].x,E[i].y),3,1);
				}
				break;
				}
			}
			if(E[i].x<0)
				E[i].flag=0;
			for(int j=0;j<100;j++)
			{
				if(T[j].syurui==0 && T[j].x+32>E[i].x && T[j].x<E[i].y+32 &&
					T[j].y+32>E[i].y && T[j].y<E[i].y+32)
				{
					E[i].flag =0;
					PlaySoundMem(SE[0] ,  DX_PLAYTYPE_BACK) ;
					ShowEx(E[i].x,E[i].y,10);
				}
			}
		}
	}
}
void CalcScroll()
{
	if(sx<0) sx=0;
	if(sx>300*16-320)
	{
		//{Xo
		sx=300*16-320;
	}
	if(sy<0) sy=0;
	if(sy>15*16-240) sy=15*16-240;

	sx++;
}

//}bv`bv`悷{̂̊֐
void DrawChip(int ChipNum,int x,int y)
{

	int g;
	//`bvio[ɉ摜̃nh	
	//`悷
	DrawGraph(x,y,MChip[ChipNum],FALSE);
	
}

//wi`悷֐(ƓGĂяo֐)
void DrawBG()
{
	int x0=sx/16,y0=sy/16;
	int x1=(sx+320)/16,y1=(sy+240)/16;

	for(int i=y0;i<=y1;i++)
	{
		for(int j=x0;j<=x1;j++)
		{
			//}bv`bv`悷
			DrawChip(Map[0][i][j],j*16-sx,i*16-sy);
			
		}
	}
}


void LoadMap()
{
	int i,j;
	FILE *fp;

	fp=fopen("./bg.txt","r");
	for(i=0;i<15;i++)
	{
		for(j=0;j<300;j++)
		{
			fscanf(fp,"%d,",&Map[0][i][j]);
		}
	}
	fclose(fp);

	fp=fopen("./emy.txt","r");
	for(i=0;i<15;i++)
	{
		for(j=0;j<300;j++)
		{
			fscanf(fp,"%d,",&Map[1][i][j]);
			if(Map[1][i][j]==255)
				Map[1][i][j]=0;
		}
	}
	fclose(fp);

	fp=fopen("./wall.txt","r");
	for(i=0;i<15;i++)
	{
		for(j=0;j<300;j++)
		{
			fscanf(fp,"%d,",&Map[2][i][j]);
		}
	}
	fclose(fp);
}



void Init()
{
	image=LoadGraph("./jiki.png");//jiki.pngǂݍ
	image2=LoadGraph("./bg.bmp");//bg.bmpǂݍ
	image3[0]=LoadGraph("./alien_typeA.png");//^Cv
	image3[1]=LoadGraph("./alien_naizou.png");//typeA̓
	LoadMap();//}bvf[^ǂݍ
	LoadDivGraph("bg.bmp" , 256 ,
		16 , 16 ,
		16 , 16 , MChip ) ;
	SE[0]=LoadSoundMem("./rec_01.wav") ;
	for(int i=0;i<100;i++)
	{
		T[i].vx=5;
		T[i].vy=5;
	}
}

void KeyCheck()
{
	static int prev=0;

	if(CheckHitKey(KEY_INPUT_UP))
	{
		y--;
		if(y<0) y=0;
	}
	if(CheckHitKey(KEY_INPUT_DOWN))
	{
		y++;
		if(y+32>240) y=240-32;
	}
	if(CheckHitKey(KEY_INPUT_LEFT))
	{
		x--;
		if(x<0) x=0;
	}
	if(CheckHitKey(KEY_INPUT_RIGHT))
	{
		x++;
		if(x+32>320) x=320-32;
	}	
	if(CheckHitKey(KEY_INPUT_UP))
	{
		roll--;
		if(roll<0) roll=0;
	}else if(CheckHitKey(KEY_INPUT_DOWN))
	{
		roll++;
		if(roll>40) roll=40;
	}else{
		if(roll>20) roll--;
		if(roll<20) roll++;
	}
	if(CheckHitKey(KEY_INPUT_Z) && !prev)
	{
		ShotTheGunLaser(x,y,2,0,5,0);
	}
	
	prev=CheckHitKey(KEY_INPUT_Z);
}
void DrawJiki()
{
	DrawRectGraph(x,y-sy,tbl[roll/10],0,32,32,image,TRUE,FALSE);
}

void ShotTheGunLaser(int x,int y,int kind,int angle,int speed,int syurui)
{
	int i;

	for(i=0;i<100;i++)
	{
		if(T[i].flag==0)//tO0Ȃ
		{
			T[i].flag =1;//tO1ɂ
			T[i].x=x;//W
			T[i].y=y;//yW
			T[i].kind =kind;//ނ
			T[i].syurui =syurui;
			T[i].angle=angle;
			T[i].speed=speed;
			break;//[v𔲂
		}
	}
}

void DrawAndMoveShot()
{
	int i;

	for(i=0;i<100;i++)
	{
		if(T[i].flag==1)
		{
			if(T[i].syurui ==0)//(@pAGp̏ꍇ)0Ȃ玩@pA1ȂGp
			{
				if(T[i].kind==0) T[i].x+=5;//kind(p[Abv̎̕)0Ȃx+=5;
				else{
					//[U[pړ\[X
					if(Map[2][(int)(T[i].y/16)][(int)(T[i].x/16)]==0)
					{
						T[i].vy*=-1;
						//map[2][y/16][x/16]
						//255ȊO(0)Ȃ甽˂
						//ȂA}bvGfB^Platinamgp
					}
					T[i].x+=T[i].vx;//lZ
					T[i].y+=T[i].vy;
				}
			}else{
				T[i].x+=cos(T[i].angle*RAD)*T[i].speed;
				T[i].y-=sin(T[i].angle*RAD)*T[i].speed;
				//w肵pxňړ
			}
			switch(T[i].kind)//p[Abv̎̕
			{
			case TAMA://TAMAȂlp`
				DrawBox(T[i].x,T[i].y,T[i].x+2,T[i].y+2,GetColor(255,0,0),TRUE);
				//
				break;
			case LASER:
				//[U[ȂA`
				DrawLine(T[i].x,T[i].y+16,T[i].x+32,T[i].y+16,GetColor(255,255,255));
				break;
			case REFLASER:
				//˃[U[ȂA_`(45xȂ̂ŁA_łnj)
					//DrawCircle(T[i].x,T[i].y,5,GetColor(255,0,0),TRUE);

					//̂̂uaU\[XڐAiȂ̂ŁA܂ӖĂ܂j
					for(int j=128;j>0;j--)
					{
						DrawPixel(xx[j],yy[j],GetColor(255,255,255));
						//_`
					}
					
					for(int k=128;k>0;k--)
					{
						xx[k]=xx[k-1];
						yy[k]=yy[k-1];
					}
					//DrawPixel(T[i].x,T[i].y,GetColor(255,0,0));
					xx[0] = T[i].x;
					yy[0] = T[i].y;
					break;
			}
			if(T[i].x>320 T[i].x<0 || T[i].y>240 || T[i].y<0) T[i].flag=0;
			//ʊOȂe
		}
	}
}

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hP,LPSTR lpC,int nC)
{
    //----------------------------------------------------------
	ChangeWindowMode(TRUE);			//EBhE[hŋN
	SetGraphMode(320,240,32);
	SetMainWindowText("Alien Wars ver0.01");
	if(DxLib_Init() == -1) return (-1);	//DXCu
	
	//f[^ǂݍݒƕ\
	DrawString( 0 , 0 , "f[^ǂݍݒ" , GetColor(255,255,255) );
	
	//̏
	srand(GetTickCount());
	
    //eϐ̏Ȃ
	Init();
    
	SetDrawScreen(DX_SCREEN_BACK);
    PlaySoundFile("./sadstarrain.mp3", DX_PLAYTYPE_LOOP ) ;
	//C[v
	while( ProcessMessage()==0 && CheckHitKey(KEY_INPUT_ESCAPE)==0){

		ProcessMessage();
		ClsDrawScreen();			//ʂ
        
		CalcScroll();
		SearchEnemy();
		DrawBG();
		KeyCheck();
		MoveEnemy();
		DrawAndMoveShot();
		DrawEnemy();
		DrawAndMoveEx();
		DrawJiki();
		
		DrawFormatString(0,0,GetColor(255,255,255),"roll=%d",roll);

		ScreenFlip();				//tbv
	}


	DxLib_End();	//DXCuI
	return (0);		//I
}